/*

  The contents of this file are subject to the Mozilla Public License Version
  1.1 (the "License"); you may not use this file except in compliance with
  the License. You may obtain a copy of the License at

           http://www.mozilla.org/MPL/

  Software distributed under the License is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
  for the specific language governing rights and limitations under the License.

  The Original Code is ActionScriptFacile Framework.

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

*/

package  
{
	import flash.display.Loader;
	import flash.net.URLRequest;
	import flash.text.TextFormat;
	
	import org.osflash.thunderbolt.Logger;
	
	import flash.text.TextField;
	import flash.events.IOErrorEvent;

	import com.actionscriptfacile.ui.text.UITextField;


	import flash.display.Sprite;
	import flash.events.Event;
	
	
	/**
	 * Exemple d'utilisation des polices partagées avec swfmill
	 * 
	 * @author Matthieu - www.actionscript-facile.com
	 */
	public class MainFD extends Sprite
	{
		protected var m_textField:UITextField;
		protected var m_textFieldFont:UITextField;
		
		public function MainFD() 
		{
			// chargement des polices partagées
			//------------------------
			var _loader:Loader = new Loader();
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, completeHandler );
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, errorHandler );
			
			var sFont:String = "http://www.actionscript-facile.com/wp-content/uploads/2011/03/fonts.swf?r="+Math.random()*28;
			Logger.debug ("url : "+sFont); // debug de l'application avec l'extension firefox Firebug
			var file:URLRequest =  new URLRequest(sFont);
			_loader.load(file );
		}

		
		/**
		 * Utilisation des polices partagées dynamiques
		 * 
		 */
		private function completeHandler(event : Event) : void
		{
			Logger.debug ("completeHandler : "+event);
			
			m_textField = new UITextField();
			m_textField.text = "Les polices partagées";
			
			m_textField.x = 10;
			m_textField.y = 10;
			m_textField.width = m_textField.maxWidth = 300;
			m_textField.height  = m_textField.maxHeight = 66;
			
			
			m_textField.changeFormat("size", 46);// changement de la taille de la police du texte
			m_textField.changeFormat("font", "QuidProQuo");// changement de la taille de la police du texte
			m_textField.changeFormat("color", Math.random() * 0X00FFFFFF);// changement de la couleur
			
			m_textField.embedFonts = true;
			addChild( m_textField );
			
			
			m_textFieldFont = new UITextField();
			m_textFieldFont.text = "ActionScript Facile";
			
			m_textFieldFont.x = 50;
			m_textFieldFont.y = 120;
			m_textFieldFont.width = m_textField.maxWidth = 450;
			m_textFieldFont.height  = m_textField.maxHeight = 130;
			
			m_textFieldFont.changeFormat("font", "Erasdemi");// changement de la taille de la police du texte
			m_textFieldFont.changeFormat("size", 46);// changement de la taille de la police du texte
			m_textFieldFont.changeFormat("color", Math.random() * 0X00FFFFFF);// changement de la couleur
		
			m_textFieldFont.embedFonts = true;			
			addChild( m_textFieldFont );
			
			
			var text:TextField = new TextField();
			text.width = stage.stageWidth;
			text.autoSize = 'center';
			text.text = "Formation AS3 Facile";
			text.htmlText = "<a href=\"http://www.formation-actionscript.com\">Formation AS3 Facile</a>";
			text.y = 250;
			
			var tFormat:TextFormat = new TextFormat();
			tFormat.font = "QuidProQuo";
			tFormat.size = 56;
			tFormat.color = Math.random() * 0X00FFFFFF;
			tFormat.url = "http://www.formation-actionscript.com";
			text.setTextFormat(tFormat);
			text.embedFonts = true;
			addChild( text );
		}
		
		private function errorHandler(e:IOErrorEvent):void 
		{
			// gestion des erreurs
			Logger.debug("erreur de chargement : " + e.text);
			
			var loader:Loader = e.target as Loader;
			loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, completeHandler );
			loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, errorHandler );

			var text:TextField = addChild( new TextField() ) as TextField;
			text.width = stage.stageWidth;
			text.autoSize = 'center';
			text.text = "Erreur : "+e.text;
		}
		
	}

}